import * as React from 'react';
import { useRef, useState } from 'react';
import { Container } from './container';
import { Executor } from './executor';
import { getStoreContext } from './store';
export const Provider = function (props) {
    const Context = getStoreContext(props.of);
    const containerRef = useRef();
    if (!containerRef.current) {
        containerRef.current = new Container();
    }
    const container = containerRef.current;
    const [initialized, setInitialized] = useState(false);
    function onChange(value) {
        setInitialized(true);
        container.state = value;
        container.notify();
    }
    return (React.createElement(Context.Provider, { value: container },
        React.createElement(Executor, { useStore: props.of, args: props.args, onChange: onChange, memo: props.memo }),
        initialized && props.children));
};
Provider.defaultProps = {
    args: [],
};
